difficult, specially due to keep the monitor output compatible, since the
network device drivers arbritary write to an string about its state,
using no pattern.

Each device is represented by a QDict. The returned QObject is a QList
containing all devices.

(qemu) info netdevices
  tap.0: vlan=0,script=/etc/kvm/kvm-ifup,downscript=/etc/kvm/kvm-ifdown,model=tap,ifname=tap0
  e1000.0: vlan=0,model=e1000,macaddr=52:54:00:12:34:56

QMP sample:
{
   "return":[
      {
         "name":"tap.0",
         "vlan":0,
         "info":{
            "script":"/etc/kvm/kvm-ifup",
            "downscript":"/etc/kvm/kvm-ifdown",
            "model":"tap",
            "ifname":"tap0"
         }
      },
      {
         "name":"e1000.0",
         "vlan":0,
         "info":{
            "model":"e1000",
            "macaddr":"52:54:00:12:34:56"
         }
      }
   ]
}

Signed-off-by: Miguel Di Ciurcio Filho <miguel.filho@gmail.com>
---
 monitor.c |    8 ++++++
 net.c     |   79 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 net.h     |    2 +
 3 files changed, 89 insertions(+), 0 deletions(-)

diff --git a/monitor.c b/monitor.c
index 4c95d7b..0d1a0c1 100644
--- a/monitor.c
+++ b/monitor.c
@@ -2423,6 +2423,14 @@ static const mon_cmd_t info_cmds[] = {
         .mhandler.info = do_info_network,
     },
     {
+        .name       = "netdevices",
+        .args_type  = "",
+        .params     = "",
+        .help       = "show information about network devices",
+        .user_print = do_info_netdevices_print,
+        .mhandler.info_new = do_info_netdevices,
+    },
+    {
         .name       = "chardev",
         .args_type  = "",
         .params     = "",
diff --git a/net.c b/net.c
index 9e8a8ab..2757ed2 100644
--- a/net.c
+++ b/net.c
@@ -34,6 +34,7 @@
 #include "monitor.h"
 #include "sysemu.h"
 #include "qemu-common.h"
+#include "qjson.h"
 #include "qemu_socket.h"
 #include "hw/qdev.h"
 
@@ -1266,6 +1267,84 @@ void do_info_network(Monitor *mon)
     }
 }
 
+static void netdevices_iter(QObject *obj, void *opaque)
+{
+
+    Monitor *mon = opaque;
+    QDict *net_device = qobject_to_qdict(obj);
+
+
+    monitor_printf(mon, "  %s: ", qdict_get_str(net_device, "name"));
+
+    if (qdict_haskey(net_device, "vlan")) {
+        monitor_printf(mon, "vlan=%d,", (int)qdict_get_int(net_device, "vlan"));
+    }
+
+    if (qdict_haskey(net_device, "peer")) {
+        monitor_printf(mon, "peer=%s,", qdict_get_str(net_device, "peer"));
+    }
+
+    monitor_printf(mon,
+        qstring_get_str(qdict_to_qstring(qdict_get_qdict(net_device,
+"info"), ",")));
+
+    monitor_printf(mon, "\n");
+
+}
+
+void do_info_netdevices_print(Monitor *mon, const QObject *ret_data)
+{
+
+    QList *net_devices;
+
+    net_devices = qobject_to_qlist(ret_data);
+
+    qlist_iter(net_devices, netdevices_iter, mon);
+
+}
+
+void do_info_netdevices(Monitor *mon, QObject **ret_data)
+{
+    VLANState *vlan;
+    VLANClientState *vc;
+    QDict *net_device;
+    QList *device_list;
+    device_list = qlist_new();
+    QObject *obj;
+
+    QTAILQ_FOREACH(vlan, &vlans, next) {
+
+        QTAILQ_FOREACH(vc, &vlan->clients, next) {
+
+            obj = qobject_from_jsonf("{ 'vlan': %d, 'name': %s }", vlan->id,
+                        vc->name);
+            net_device = qobject_to_qdict(obj);
+
+            QINCREF(vc->info_dict);
+            qdict_put(net_device, "info", vc->info_dict);
+
+            qlist_append(device_list, net_device);
+
+        }
+    }
+
+    QTAILQ_FOREACH(vc, &non_vlan_clients, next) {
+        obj = qobject_from_jsonf("{ 'name': %s }", vc->name);
+        net_device = qobject_to_qdict(obj);
+
+        QINCREF(vc->info_dict);
+        qdict_put(net_device, "info", vc->info_dict);
+
+        if (vc->peer) {
+            qdict_put(net_device, "peer", qstring_from_str(vc->peer->name));
+        }
+
+        qlist_append(device_list, net_device);
+    }
+
+    *ret_data = QOBJECT(device_list);
+}
+
 int do_set_link(Monitor *mon, const QDict *qdict, QObject **ret_data)
 {
     VLANState *vlan;
diff --git a/net.h b/net.h
index 4566f7d..9b3700c 100644
--- a/net.h
+++ b/net.h
@@ -120,6 +120,8 @@ int qemu_find_nic_model(NICInfo *nd, const char * const *models,
                         const char *default_model);
 
 void do_info_network(Monitor *mon);
+void do_info_netdevices_print(Monitor *mon, const QObject *ret_data);
+void do_info_netdevices(Monitor *mon, QObject **ret_data);
 int do_set_link(Monitor *mon, const QDict *qdict, QObject **ret_data);
 
 /* NIC info */